﻿package com
{
	import flash.display.*;
	import flash.events.*;
	import flash.net.*;
	import flash.utils.getDefinitionByName;
	import flash.geom.Rectangle;
	
	public class Main extends MovieClip
	{
		private var measureUniMC:MovieClip = new MovieClip;
		private var xml:XML = new XML();
		private var dropElementsArr:Array = new Array();
		private var dragMC:MovieClip = new MovieClip();
		
		public function Main():void
		{
			var urlLoader:URLLoader = new URLLoader();
			urlLoader.load(new URLRequest("xml/image.xml"));
			urlLoader.addEventListener(Event.COMPLETE, fnXMLLoadComp);
		}
		
		private function fnXMLLoadComp(eve:Event):void{
			xml = XML(eve.target.data);
			for(var i:int = 0; i < 2; i++){
				var mcClass:Class = getDefinitionByName("drag_"+i+"_mc") as Class;
				dragMC = new mcClass();
				dragMC.x = xml.dragPos.pos[i].@xPos;
				dragMC.y = xml.dragPos.pos[i].@yPos;
				addChild(dragMC);
				dragMC.mouseChildren = false;
				dragMC.name = "drag_"+i+"_mc";
				dragMC.addEventListener(MouseEvent.MOUSE_DOWN, fnCreateDrag);
			}
			addChild(measureUniMC);
			reset_btn.addEventListener(MouseEvent.CLICK, fnReset);
		}
		
		private function fnCreateDrag(e:MouseEvent):void{
			var mcClass:Class = getDefinitionByName(e.target.name) as Class;
			fnCreateDupDrag(mcClass, e.target.name);
		}
		
		private function fnCreateDupDrag(mcClass:Class, nam:String):void{
			dragMC = new mcClass();
			measureUniMC.addChild(dragMC);
			dragMC.x = mouseX;
			dragMC.y = mouseY;
			dragMC.name = "drag_"+nam.split("_")[1];
			dragMC.startDrag(false, new Rectangle(0,0,750,520));
			dragMC.addEventListener(MouseEvent.MOUSE_UP, fnCheckHitTest);
		}
		
		private function fnCheckHitTest(eve:MouseEvent):void{	
			
			dragMC = eve.target as MovieClip;	
			var ind:int = dragMC.name.split("_")[1];
			var flag:Boolean = false;
			for(var i:int = 0; i < 3; i++){
				var dropMC:MovieClip = getChildByName("drop_"+i+"_mc") as MovieClip;
				var xPos:Number = 0;
				var yPos:Number = 0;
				if(dragMC.hitTestObject(dropMC)){					
					flag = true;
					var tempArr:Array = new Array();
					if(dropElementsArr[i] == undefined){
						dropElementsArr[i] = [];
					}
					if(dropElementsArr[i][0] == undefined){
						dropElementsArr[i][0] = [];
					}
					if(dropElementsArr[i][1] == undefined){
						dropElementsArr[i][1] = [];
					}
					
					if(ind == 0){
						tempArr = dropElementsArr[i][0];
						xPos = xml.dropPos.pos[i].@x1;
						yPos = xml.dropPos.pos[i].@y1;
					}else{
						tempArr = dropElementsArr[i][1];
						xPos = xml.dropPos.pos[i].@x2;
						yPos = xml.dropPos.pos[i].@y2;
					}
					
					var wid:Number = 0;
					var hei:Number = 0;
					if(tempArr.length>0){
						if(ind == 0){
							wid = tempArr.length * (tempArr[0].width-10);
						}else
						{
							wid = tempArr.length * (tempArr[0].width-2);
						}
						hei = tempArr.length * tempArr[0].height;
					}
					dragMC.stopDrag();
					dragMC.removeEventListener(MouseEvent.MOUSE_UP, fnCheckHitTest);
					dragMC.doubleClickEnabled=true;
					dragMC.id=i;
					dragMC.addEventListener(MouseEvent.DOUBLE_CLICK, removeObject);
					if(i == 2){
						if(hei < dropMC.height){
							if(dragMC.name == "drag_1"){
								dragMC.rotation = -90;
							}
							
							dragMC.x = xPos;							
							dragMC.y = yPos - hei - dragMC.height/2 + 5;
							
							if(ind == 0){
								dropElementsArr[i][0].push(dragMC);
							}else{
								dropElementsArr[i][1].push(dragMC);
							}
						}else{
							measureUniMC.removeChild(dragMC);
						}
					}else{
						if(wid < dropMC.width){							
							
							if(dragMC.name=="drag_0")
							{
								dragMC.rotation=21.5;								
								dragMC.x = xPos +wid + dragMC.width/2;								
							}else
							{								
								dragMC.x = xPos + wid + dragMC.width/2;
							}
							
							dragMC.y = yPos;	
							
							
							if(ind == 0){
								
								dropElementsArr[i][0].push(dragMC);
							}else{
								
								dropElementsArr[i][1].push(dragMC);
							}					
						}else{
							measureUniMC.removeChild(dragMC);
						}
					}
					break;
				}
			}
			if(!flag){
				var drag1:MovieClip = getChildByName("drag_0_mc") as MovieClip;
				var drag2:MovieClip = getChildByName("drag_1_mc") as MovieClip;
				var mcClass:Class;
				if(dragMC.hitTestObject(drag1)){
					measureUniMC.removeChild(dragMC);
					mcClass = getDefinitionByName("drag_0_mc") as Class;
					fnCreateDupDrag(mcClass, "drag_0_mc");
					
				}else if(dragMC.hitTestObject(drag2)){
					measureUniMC.removeChild(dragMC);
					mcClass = getDefinitionByName("drag_1_mc") as Class;
					fnCreateDupDrag(mcClass, "drag_1_mc");
				}
			}
		}
		
		private function removeObject(e:MouseEvent)
		{
			measureUniMC.removeChild(MovieClip(e.target));			
			
			var xpos:Number;
			var ypos:Number;
			
			if(e.currentTarget.name=="drag_0")
			{
				dropElementsArr[e.currentTarget.id][0].pop();
				xpos = xml.dropPos.pos[e.currentTarget.id].@x1;				
				ypos = xml.dropPos.pos[e.currentTarget.id].@y1;
				
				if(e.currentTarget.id!=2)
				{
				  	 xpos=xpos+29;
				}else
				{
					ypos=ypos-17;
				}
			}else if(e.currentTarget.name=="drag_1")
			{
				dropElementsArr[e.currentTarget.id][1].pop();
				xpos = xml.dropPos.pos[e.currentTarget.id].@x2;
				
				ypos = xml.dropPos.pos[e.currentTarget.id].@y2;
				if(e.currentTarget.id!=2)
				{
					xpos=xpos+31;
				}else
				{
					ypos=ypos-26;
				}
			}			
			
			var count:int=0;			
				
			for(var noOfObj:int=0; noOfObj<measureUniMC.numChildren;noOfObj++)
			{			
				var dragMc=measureUniMC.getChildAt(noOfObj)					
					
				if((e.currentTarget.id==dragMc.id) && (dragMc.name==e.currentTarget.name))
				{					
					if(e.currentTarget.id!=2)
					{						
						if(dragMc.name=="drag_0")
						{
							
							measureUniMC.getChildAt(noOfObj).x= xpos + (((dragMc.width)-10)*count);
						}else if(dragMc.name=="drag_1")
						{							
							measureUniMC.getChildAt(noOfObj).x= xpos + (((dragMc.width)-2)*count);
						}
					}else
					{
						if(dragMc.name=="drag_0")
						{
							measureUniMC.getChildAt(noOfObj).y= ypos - ((dragMc.height)*count);
						}else if(dragMc.name=="drag_1")
						{
							measureUniMC.getChildAt(noOfObj).y= ypos - ((dragMc.height)*count);
						}
					}					
					
					count++;
				}
				
					
			}		
			
		}
		
		
		private function fnReset(eve:MouseEvent):void{
			var len:Number = measureUniMC.numChildren;
			removeChild(measureUniMC);
			measureUniMC = new MovieClip();
			addChild(measureUniMC);
			dropElementsArr = [];
		}
		
	}
}