﻿package {
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.net.URLRequest;
	import flash.net.URLLoader;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFieldAutoSize;
	import flash.geom.ColorTransform;
	import flash.geom.Rectangle;
	import flash.display.Loader;
	import flash.utils.getDefinitionByName;
	import flash.text.Font;

	public class AddingCards {
		private var targetClip:MovieClip;
		private var xmlData:XML;
		private var actType:String;
		private var circleArr:Array;
		private var leftCardNum:Number;
		private var rightCardNum:Number;
		private var cardType:Number;
		private var numType:Number;		
		private var leftCardType:String;
		private var rightCardType:String;
		private var fromRange:Number;
		private var toRange:Number;
		private var loadedCount:Number;
		private var selectedCircle:Number;
		private var selectedBtn:MovieClip = new MovieClip();

		public function AddingCards(target:MovieClip):void {
			targetClip = target;
			targetClip.visible = false;
			xmlData = new XML();
			circleArr = new Array();
			loadedCount = 0;
			actType = "";
			cardType = -1;
			numType = 0;			
		}
		public function setUp(url:String):void {
			enableBtns(false);
			loadXML(url);
			
		}		
		private function randomRange(prevRndNum:Number,max:Number, min:Number = 0):Number
		{
			if(max == min) return max;
			var currRnd:Number = Math.round(Math.random() * (max - min) + min);
			var prevRnd:Number = prevRndNum;
			if(prevRnd == currRnd){
				currRnd = randomRange(prevRnd,max,min);
			}			
			return currRnd;
		}				
		private function enableBtns(val:Boolean):void{
			targetClip.reset_btn.enabled = val;				
			if(val){
				targetClip.reset_btn.addEventListener(MouseEvent.CLICK,function(){
					leftCardNum = -1;
					rightCardNum = -1;
					selectedBtn = null;
					reset();
				});
				if(actType == "random"){
					targetClip.randomBtn.visible = false;
					targetClip.doubleBtn.visible = false;
					targetClip.nearBtn.visible = false;
				}else{
					
					targetClip.randomBtn.addEventListener(MouseEvent.CLICK,function(){
						reset();
						leftCardNum = randomRange(leftCardNum,1,10);
						rightCardNum = randomRange(rightCardNum,1,10);
						loadLeftPage();
						loadRightPage();
					});
					
					targetClip.doubleBtn.addEventListener(MouseEvent.CLICK,function(){
						reset();
						leftCardNum = randomRange(leftCardNum,1,10);
						rightCardNum = leftCardNum;
						loadLeftPage();
						loadRightPage();
					});

					targetClip.nearBtn.addEventListener(MouseEvent.CLICK,function(){
						reset();
						numType = randomRange(numType,0,1)
						leftCardNum = randomRange(leftCardNum,1,10);
						rightCardNum = leftCardNum + ((numType==0)? -1 : 1);
						if(rightCardNum<1 || rightCardNum>10){
							rightCardNum = leftCardNum;
							if(leftCardNum==10)
							leftCardNum = leftCardNum-1;
							if(leftCardNum==1)
							leftCardNum = leftCardNum+1;
						}
						loadLeftPage();
						loadRightPage();
					});
				}
			}
		}
		private function loadXML(path:String) {
			var urlRequest:URLRequest=new URLRequest(path);
			var urlLoader:URLLoader=new URLLoader(urlRequest);
			urlLoader.addEventListener(Event.COMPLETE, xmlLoaded);
		}
		private function xmlLoaded(e:Event):void {
			xmlData = new XML(e.target.data);
			circleArr = [];			
			selectedCircle = -1;
			leftCardNum = -1;
			rightCardNum = -1;
			fromRange = Number(xmlData.circle.@rangeFrom);
			toRange = Number(xmlData.circle.@rangeTo);
			actType = (xmlData.@type.toString().length>0) ? xmlData.@type.toLowerCase() : "";
			enableBtns(true);
			drawCircles();
			drawFeedback();
			reset();			
			targetClip.visible = true;
		}
		public function reset():void {
			var leftPage:MovieClip = targetClip.getChildByName("leftPage") as MovieClip;
			if(leftPage!=null) targetClip.removeChild(leftPage);
			var rightPage:MovieClip = targetClip.getChildByName("rightPage") as MovieClip;
			if(rightPage!=null) targetClip.removeChild(rightPage);
			loadedCount = 0;			
			clearSelectedCircle();	
			var feedback:MovieClip=targetClip.getChildByName("feedback") as MovieClip;
			feedback.visible = false;
			if(actType == "random"){
				leftCardNum = randomRange(leftCardNum,1,10);
				rightCardNum = randomRange(rightCardNum,1,10);
				loadLeftPage();
				loadRightPage();
			}
		}		
			
		private function drawCircles():void{
			var circleClip:MovieClip = new MovieClip();
			circleClip.name = "circleClip";
			var col:Number = Number(xmlData.circle.@col);			
			var radius:Number = Number(xmlData.circle.@radius);
			var gap:Number = Number(xmlData.circle.@gap);
			for(var i=0;i<=(toRange-fromRange);i++){
				var circle:MovieClip = new MovieClip();
				circle.name = "circle_"+i;				
				var bg:MovieClip = new MovieClip();
				bg.name = "bg";
				var border:MovieClip = new MovieClip();
				border.name = "border";
				circleArr[i] = i+fromRange;
				border.graphics.lineStyle(Number(xmlData.circle.@borderSize),Number(xmlData.circle.@borderColor),(Number(xmlData.circle.@borderSize)==0)?0:1);
				bg.graphics.beginFill(Number(xmlData.circle.@bgColor), 1);
				bg.graphics.drawCircle(0,0,radius);
				border.graphics.drawCircle(0,0,radius);
				circle.addChild(bg);
				circle.addChild(border);
				
				var txt:TextField = addTxt("txt",circleArr[i].toString());
				changeFormat(txt,xmlData.circle.@font,Number(xmlData.circle.@fontSize),uint(xmlData.circle.@fontColor),"center");
				txt.x = circle.x - txt.width/2 - 1;
				txt.y = circle.y - txt.height/2;
				txt.embedFonts = true;
				circle.x = (i%col) * (circle.width + gap);				
				circle.y = (Math.floor(i/col) * (circle.height + gap));	
				circle.addChild(txt);
				circleClip.addChild(circle);
				circle.mouseChildren = false;
				circle.addEventListener(MouseEvent.CLICK,circleClicked);
			}
			circleClip.x = Number(xmlData.circle.@x);
			circleClip.y = Number(xmlData.circle.@y); 
			targetClip.addChild(circleClip);
		}
		private function drawFeedback():void {
			var feedback:Feedback = new Feedback();
			feedback.name="feedback";
			feedback.x=Number(xmlData.feedback.@x);
			feedback.y=Number(xmlData.feedback.@y);
			feedback.visible=false;
			targetClip.addChild(feedback);
		}		
		private function circleClicked(e:MouseEvent):void{	
			if(loadedCount>1){
				clearSelectedCircle();
				var circle:MovieClip = e.target as MovieClip;
				selectedCircle = Number(e.target.name.split("_")[1]);
				if(circleArr[selectedCircle] == (leftCardNum+rightCardNum)){
					changeColor(circle,uint(xmlData.circle.@correctColor));
					showFeedback(true);				
				}else{
					changeColor(circle,uint(xmlData.circle.@selectedColor));
					showFeedback(false);
				}
			}
		}
		
		private function loadLeftPage():void {
			var leftPage:Card = new Card();
			leftPage.name="leftPage";			
			cardType = randomRange(cardType,0,3);
			switch(cardType){
				case 0:
					leftCardType = "diamond";
				break;
				case 1:
					leftCardType = "flower";
				break;
				case 2:
					leftCardType = "heart";
				break;
				case 3:
					leftCardType = "spade";
				break;
			}			
			leftPage.gotoAndStop(leftCardType+leftCardNum);
			leftPage.x = Number(xmlData.bigcard.@x);
			leftPage.y = Number(xmlData.bigcard.@y);
			leftPage.width = Number(xmlData.bigcard.@width);
			leftPage.height = Number(xmlData.bigcard.@height);
			targetClip.addChild(leftPage);
			loadedCount++;
		}
		private function loadRightPage():void {
			var leftPage:MovieClip=targetClip.getChildByName("leftPage") as MovieClip;
			var rightPage:Card = new Card();
			rightPage.name="rightPage";			
			cardType = randomRange(cardType,0,3);
			switch(cardType){
				case 0:
					rightCardType = "diamond";
				break;
				case 1:
					rightCardType = "flower";
				break;
				case 2:
					rightCardType = "heart";
				break;
				case 3:
					rightCardType = "spade";
				break;
			}			
			rightPage.gotoAndStop(rightCardType+rightCardNum);
			rightPage.x = leftPage.x + leftPage.width + Number(xmlData.bigcard.@gap);
			rightPage.y = leftPage.y;
			rightPage.width = Number(xmlData.bigcard.@width);
			rightPage.height = Number(xmlData.bigcard.@height);
			targetClip.addChild(rightPage);
			loadedCount++;
		}
		private function addTxt(name:String,txtStr:String):TextField{
			var txt:TextField = new TextField();
			txt.name = name;
			txt.selectable = false;
			txt.background = false;
			txt.border = false;
			txt.text = txtStr;
			txt.autoSize = TextFieldAutoSize.LEFT;
			
			return txt;
		}
		private function clearSelectedCircle():void{
			if(selectedCircle!=-1){
				var circleClip:MovieClip = targetClip.getChildByName("circleClip") as MovieClip;
				var prevCircle:MovieClip = circleClip.getChildByName("circle_"+selectedCircle) as MovieClip;
				changeColor(prevCircle,uint(xmlData.circle.@bgColor));
			}
		}
		private function changeFormat(targetTxt:TextField,font:String,fontSize:Number,fontColor:uint,align:String=null):void{
			var txt:TextField = targetTxt;
			var txtFormat:TextFormat = new TextFormat();
			txtFormat.leftMargin = 0;
			txtFormat.rightMargin = 0;
			var FontC=getDefinitionByName(font) as Class;
			var newFont:Font=new FontC();
			txtFormat.font=newFont.fontName;
			txtFormat.bold = true;			
			txtFormat.size = fontSize;
			txtFormat.color = fontColor;
			if(align!=null) txtFormat.align = align;
			txt.setTextFormat(txtFormat);
		}
		private function changeColor(target:MovieClip,color:uint):void{
			var bg:MovieClip = target.getChildByName("bg") as MovieClip;			
			var cColor:ColorTransform = new ColorTransform();
			cColor.color = color;
			bg.transform.colorTransform = cColor;			
		}
		private function showFeedback(isCorrect:Boolean):void {
			var feedback:MovieClip=targetClip.getChildByName("feedback") as MovieClip;
			if (isCorrect) {
				feedback.gotoAndStop(2);
			} else {
				feedback.gotoAndStop(1);
			}
			feedback.visible = true;
		}
	}
}