﻿package {
	
	import flash.display.*;
	import flash.events.MouseEvent;
	import flash.geom.*;
	import flash.utils.getDefinitionByName;
	
	public class PickColor extends MovieClip {
		
		var shapeArr = ["", "triangle", "square", "hexagon", "parallogram", "recParalel", "trapezoid"];
		var colorArr = [0,0xED008C, 0xF68121, 0xFFDE00, 0x40AF49, 0xED1B24, 0x005FAF, 0x782B91];
		
		var targ;
		var dispArr = [0xED008C, 0xF68121, 0xFFDE00, 0x40AF49, 0xED1B24, 0x005FAF];
		var _shapes = new MovieClip();
		
		var startPoint:Point;
		var drawLayer:Sprite;
		var selectionRect:Rectangle;
		
		public function PickColor() {
			// constructor code
			init();
		}
		
		function init()
		{
			for (var i:int = 1; i <= 6; i++) {
				var shp = getChildByName("shape_" + i);
				
				var colorTra:ColorTransform = new ColorTransform();
				colorTra.color = dispArr[i - 1];
				shp._base.transform.colorTransform = colorTra;
				
				shp.addEventListener(MouseEvent.CLICK, addShapeHandle);
				shp.mouseChildren = false;
			}
			
			for(i=1;i<=7;i++)
			{
				clrPickerMC["mc_" + i].addEventListener(MouseEvent.CLICK, fnChangeGridColorCode);
				clrPickerMC["hi"+i].visible=false;
				clrPickerMC["hi"+i].mouseEnabled=false;
			}
			addChild(_shapes);
			drawLayer = new Sprite();
			addChild(drawLayer);
			_base.addEventListener(MouseEvent.MOUSE_DOWN, startSelect);
			reset_btn.addEventListener(MouseEvent.CLICK, onResetClick);
		}
		
		
		function onResetClick(eve):void 
		{
			while (_shapes.numChildren)
			_shapes.removeChildAt(0);
		}
		
		
		//Changes the grid color with the selected color
		private function fnChangeGridColorCode(eve:MouseEvent):void {
			
			var colorNum = eve.target.name.split("_")[1];
			for(var i:int=1;i<=7;i++)
			{
				clrPickerMC["hi"+i].visible=false;
			}
			clrPickerMC["hi" + colorNum].visible = true;
			//var colorArr = [0,0xED008C, 0xF68121, 0xFFDE00, 0x40AF49, 0xED1B24, 0x005FAF, 0x782B91];
			var color = colorArr[colorNum];
			var colorTransform:ColorTransform = new ColorTransform();
			colorTransform.color = color;
			if (targ) 
			{
				if (targ.grouped)
				{
				for (i = 0; i < targ.parent.numChildren; i++) {
					targ.parent.getChildAt(i)._base.transform.colorTransform = colorTransform;
				}
				}else 
				{
					targ._base.transform.colorTransform = colorTransform;
				}
			}
		}
		
		
		function addShapeHandle(eve)
		{
			var shpnum = eve.currentTarget.name.split("_")[1];
			var newClass = getDefinitionByName(shapeArr[shpnum]);
			var obj = new newClass();
			_shapes.addChild(obj);
			
			obj.x = 380;
			obj.y = 200;
			
			var xran = ((Math.random() * 10) - 5) * 10;
			var yran = ((Math.random() * 10) - 5) * 10;
			
			obj.x += xran;
			obj.y += yran;
			
			obj._base.addEventListener(MouseEvent.MOUSE_DOWN, objStartDrag)
			obj._base.doubleClickEnabled = true;
			obj._base.addEventListener(MouseEvent.DOUBLE_CLICK, objRemove)
			targ = obj;
			var colorTransform:ColorTransform = new ColorTransform();
			colorTransform.color = dispArr[shpnum-1];
			targ._base.transform.colorTransform = colorTransform;
			
			addRotateEvents(targ);
		}
		
		function objRemove(eve):void {
			var obj = eve.target.parent;
			if (obj.grouped) 
			{
				obj = obj.parent;
			}
			_shapes.removeChild(obj);
		}
		
		function objStartDrag(eve):void 
		{
			targ = eve.currentTarget.parent;
			if (targ.grouped)
			{
				targ.parent.startDrag();
			}
			else 
			{
				targ.startDrag();
			}

			stage.addEventListener(MouseEvent.MOUSE_UP, objStopDrag);
		}
		
		function objStopDrag(eve):void 
		{
			targ.stopDrag();
			stage.removeEventListener(MouseEvent.MOUSE_UP, objStopDrag);
			checkColide(targ);
		}
		
		function checkColide(drag) 
		{
			for (var i = 1; i <= 6; i++)
			{
				var dragbtn = drag.getChildByName("btn_" + i);
				if (dragbtn != null)
				{
					for (var j = 0; j < _shapes.numChildren; j++) 
					{
						var drop = _shapes.getChildAt(j);
						if(drag != drop)
						{
							for (var k = 1; k <= 6; k++) 
							{
								var dropbtn = drop.getChildByName("btn_" + k);
								if (dropbtn != null) 
								{
									if (dragbtn.hitTestObject(dropbtn))
									{
										var pt:Point = new Point(dropbtn.x, dropbtn.y);
										pt = dropbtn.parent.localToGlobal(pt);
										pt = _shapes.globalToLocal(pt);
										
										var pt2:Point = new Point(dragbtn.x, dragbtn.y);
										pt2 = dragbtn.parent.localToGlobal(pt2);
										pt2 = _shapes.globalToLocal(pt2);
										var diffPt:Point = new Point(pt.x - pt2.x, pt.y - pt2.y)
										drag.x = drag.x + diffPt.x;
										drag.y = drag.y + diffPt.y;
										return;
									}
								}
								
							}
						}
					}
				}
				
			}
		}
		
		///// selection Code
		function startSelect(e:MouseEvent):void
		{
			startPoint = globalToLocal(new Point(e.stageX, e.stageY));
			_base.addEventListener(MouseEvent.MOUSE_MOVE, onSelect);
			stage.addEventListener(MouseEvent.MOUSE_UP, stopSelect);
		}
		
		function onSelect(e:MouseEvent):void {
			drawLayer.graphics.clear();
			drawLayer.graphics.lineStyle(1, 0x000000);
			
			var	lastPoint:Point = globalToLocal(new Point(e.stageX, e.stageY));
			
			var newx:int = lastPoint.x;
			var newy:int = lastPoint.y;
			var top:int = Math.min(newy, startPoint.y);
			var left:int = Math.min(newx, startPoint.x);
			var w:int = Math.abs(newx - startPoint.x);
			var h:int = Math.abs(newy - startPoint.y);
			drawLayer.graphics.drawRect(left, top, w, h);
			selectionRect = new Rectangle(left, top, w, h);
		}
		
		function stopSelect(e:MouseEvent):void {
			drawLayer.graphics.clear();
			
			// The list of items contained in the selection.
			var selection:Array = new Array();
			
			// The rectangle that defines the selection in the containers coordinate space.
			
			// Loop throught the containers children.
			for (var a:int; a < _shapes.numChildren; a++) {
				// Get the childs bounds in the containers coordinate space.
				var child = _shapes.getChildAt(a);
				var childBounds:Rectangle = child.getRect(_shapes);
				
				// Check if this childs bounds against the selection bounds
					if (childBounds.intersects(selectionRect) )
					{
						if (child.type == "packSpr") 
						{
							while (child.numChildren)
							{
								var temChd = child.getChildAt(0);
								selection.push(temChd);
								_shapes.addChild(temChd);
								temChd.x += child.x;
								temChd.y += child.y;
								//_shapes.removeChild(child);
							}							
						}
						else
						{
							selection.push(child);
						}
					}
				
			}
			
			if (selection.length > 1) {
				var packSpr = new MovieClip();
				var gpX, gpY;
				for (var i:int = 0; i < selection.length; i++) {
					selection[i].grouped = true;
					packSpr.type = "packSpr";
					packSpr.addChild(selection[i]);
					targ = selection[i];
				}
				setRegPoint(packSpr, packSpr.width / 2, packSpr.height / 2);
				_shapes.addChild(packSpr);
				
				
			}
			_base.removeEventListener(MouseEvent.MOUSE_MOVE, onSelect);
			stage.removeEventListener(MouseEvent.MOUSE_UP, stopSelect);
		}
		
		///Rotation code
		function setRegPoint(obj:DisplayObjectContainer, newX:Number, newY:Number):void {
			//get the bounds of the object and the location 
			//of the current registration point in relation
			//to the upper left corner of the graphical content
			//note: this is a PSEUDO currentRegX and currentRegY, as the 
			//registration point of a display object is ALWAYS (0, 0):
			var bounds:Rectangle = obj.getBounds(obj.parent);
			var currentRegX:Number = obj.x - bounds.left;
			var currentRegY:Number = obj.y - bounds.top;
			
			var xOffset:Number = newX - currentRegX;
			var yOffset:Number = newY - currentRegY;
			//shift the object to its new location--
			//this will put it back in the same position
			//where it started (that is, VISUALLY anyway):
			obj.x += xOffset;
			obj.y += yOffset;
			
			//shift all the children the same amount,
			//but in the opposite direction
			for (var i:int = 0; i < obj.numChildren; i++) {
				obj.getChildAt(i).x -= xOffset;
				obj.getChildAt(i).y -= yOffset;
			}
		}
		
		
		var rot:Number = 0;
		
		function addRotateEvents(obj):void 
		{
			for (var i:int = 1; i <= 6; i++) 
			{
				var btn = obj.getChildByName("btn_" + i);
				if (btn) {
					btn.addEventListener(MouseEvent.MOUSE_DOWN, startRotate);
				}
			}
		}
		
		function startRotate(e:MouseEvent):void {
			targ = e.target.parent;
			if (targ.grouped) {
				targ = targ.parent;
			}
			
			rot = (180 * Math.atan2(mouseY - targ.y, mouseX - targ.x)) / Math.PI + 90 - targ.rotation;
			stage.addEventListener(MouseEvent.MOUSE_UP, stopRotate);
			stage.addEventListener(MouseEvent.MOUSE_MOVE, onRotateObject);
		}
		function stopRotate(e:MouseEvent):void {
			stage.removeEventListener(MouseEvent.MOUSE_MOVE, onRotateObject);
		}
		function onRotateObject(e:MouseEvent):void {
			targ.rotation = ((180*Math.atan2(mouseY-targ.y,mouseX-targ.x))/Math.PI + 90) - rot;
		}

	}

}
