﻿package 
{
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	import flash.display.SimpleButton;
	
	
	public class Calendar extends MovieClip
	{
		private var monthLabels:Array = new Array("January","February","March","April","May","June","July","August","September","October","November","December");
		private var weekDayLabels:Array = new Array("Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday");
		private var calendar:calendarMc;
		private var selectedDays:Array = new Array();
		private var textDefaultColor:String = "0x000000";
		private var textHighlightColor:String = "0x0066FF";
		private var today;
		private var todaysday;
		private var currentyear;
		private var currentmonth;
		private var startDay:Number = 0;
		private var totalDays:Number = 0;
		private var container:MovieClip;
		
		public function Calendar(cont:MovieClip) 
		{
			container = cont;
			calendar = new calendarMc();
			calendar.x = 82
			calendar.y = 20;
			container.addChild(calendar);
			init();
			
		}
		private function addListeners()
		{
			for(var i=0; i< 42; i++)
			{
				calendar["txt_"+i].bg.gotoAndStop(1);
				calendar["txt_"+i].states.gotoAndStop(1);
				calendar["txt_"+i].addEventListener(MouseEvent.CLICK, clickFun);
				calendar["txt_"+i].addEventListener(MouseEvent.MOUSE_OVER, mouseOverFun);
				calendar["txt_"+i].addEventListener(MouseEvent.MOUSE_OUT, mouseOutFun);
			}
		}
		public function init()
		{
			calendar.leftArrow.addEventListener(MouseEvent.CLICK, leftArrowFun);
			calendar.rightArrow.addEventListener(MouseEvent.CLICK, rightArrowFun);
			container.reset_btn.addEventListener(MouseEvent.CLICK, resetFun);
			trace("reset "+calendar.stage)
			
			setTodayDate();
			addListeners();
			setCalendar();
			
		}
		public function setTodayDate()
		{
			today = new Date();
			todaysday = today.getDay();
			currentyear = today.getFullYear();
			currentmonth = today.getMonth();
			calendar.MonthName.text = String( monthLabels[currentmonth] + " " + currentyear );
		}
		
		public function setCalendar()
		{
			startDay = 0;
			totalDays = 0;
			var i:int = 0;
			var j:int = 0;
			var dates:String;
			for(i=0; i< 42; i++)
			{
				calendar["txt_"+i].bg.gotoAndStop(1);
				calendar["txt_"+i].Day.text = "";
				calendar["txt_"+ i].alpha = 1;
				calendar["txt_"+ i].visible = true;
			}
			var date:Date = new Date(currentyear, currentmonth, 1);
			startDay = sysDayToOurDay(date.getDay());
			date = new Date(currentyear, currentmonth+1, 0)
			totalDays = date.getDate();
			
			for(i = 1; i<= totalDays; i++)
			{
				calendar["txt_"+ (i+startDay-1) ].Day.text = i;
				
				if(isTodayDate(currentyear, currentmonth, i))
				{
					calendar["txt_"+ (i+startDay-1) ].bg.gotoAndStop(2);
				}
				dates = String(currentyear) + "_" + String(currentmonth) + "_" + String(i);
				if(isDateSelected(dates))
				{
					calendar["txt_"+ (i+startDay-1) ].bg.gotoAndStop(3);
				}
			}
			calendar.MonthName.text = String( monthLabels[currentmonth] + " " + currentyear );
			
			//////////////////  for previous months days /////////////////
			if(startDay > 0)
			{
				date = new Date(currentyear, currentmonth, 0);
				j = date.getDate();
				trace("prev month "+j, date.getMonth())
				for( i = startDay-1; i >= 0; i--,j-- )
				{
					dates = String(date.getFullYear()) + "_" + String(date.getMonth()) + "_" + String(j);
					if(isDateSelected(dates))
					{
						calendar["txt_"+ i ].bg.gotoAndStop(3);
					}
					calendar["txt_"+ i].Day.text = j;
					calendar["txt_"+ i].visible = false;
				}
			}
			
			///////////////////  for next month days //////////////////////
			
			date = new Date(currentyear, currentmonth+1, 1);
			j = date.getDate();
			trace("next month "+j)
			//trace("startDay "+startDay)
			for( i = totalDays+startDay; i < 42; i++,j++ )
			{
				dates = String(date.getFullYear()) + "_" + String(date.getMonth()) + "_" + String(j);
				if(isDateSelected(dates))
				{
					calendar["txt_"+ i ].bg.gotoAndStop(3);
				}
				calendar["txt_"+ i].Day.text = j;
				calendar["txt_"+ i].visible = false;
			}
			
		}
		
		public function leftArrowFun(e:MouseEvent = null)
		{
			var date:Date = new Date(currentyear, currentmonth-1, 1);
			//trace("m1 "+date.month)
			currentmonth = date.getMonth();
			//trace("y1 "+date.getFullYear())
			currentyear = date.getFullYear();
			setCalendar();
		}
		
		public function rightArrowFun(e:MouseEvent = null)
		{
			var date:Date = new Date(currentyear, currentmonth+1, 1);
			currentmonth = date.getMonth();
			currentyear = date.getFullYear();
			setCalendar();
		}
		
		public function sysDayToOurDay(d:int):int
		{
			var day = d - 1;
			if(day == -1)
			{
				day = 6;
			}
			return day;
		}
		
		private function isTodayDate(y:Number, m:Number, d:Number)
		{
			var date:Date = new Date();
			//trace(date);
			if(date.getFullYear() == y && date.getMonth() == m && date.getDate() == d)
			{
				return true;
			}
			return false;
		}
		
		private function isDateSelected(date:String):Boolean
		{
			if(selectedDays.indexOf(date) != -1)
			{
			   return true;
			}
			return false;
		}
		private function clickFun(e:MouseEvent)
		{
			var mc:MovieClip = MovieClip(e.currentTarget);
			var date:int = (mc.name.split("_"))[1];
			var cdate:Date;
			var currentDate:int = 1 + date - startDay;
			//trace("currentDate "+currentDate);
			var markedDate:String;
			if(date >= startDay && date <= (startDay + totalDays - 1) )
			{
				currentDate = 1 + date - startDay;
				markedDate = String(currentyear) + "_" + String(currentmonth) + "_" + String(currentDate);
				makeMarked(markedDate, mc);
			}
			else if(date<startDay)
			{
				cdate = new Date(currentyear, currentmonth-1, mc.Day.text);
				markedDate = String(cdate.getFullYear()) + "_" + String(cdate.getMonth()) + "_" + String(cdate.getDate());
				makeMarked(markedDate, mc);
				leftArrowFun();
			}
			else if(date > (startDay + totalDays - 1))
			{
				cdate = new Date(currentyear, currentmonth+1, mc.Day.text);
				markedDate = String(cdate.getFullYear()) + "_" + String(cdate.getMonth()) + "_" + String(cdate.getDate());
				makeMarked(markedDate, mc);
				rightArrowFun();
			}
			
		}
		private function makeMarked(markedDate:String, mc:MovieClip)
		{
			if( isDateSelected(markedDate) )
			{
				selectedDays.splice(selectedDays.indexOf(markedDate),1);
				mc.bg.gotoAndStop(1);
			}
			else
			{
				mc.bg.gotoAndStop(3);
				selectedDays.push(markedDate);
			}
		}
		private function mouseOverFun(e:MouseEvent)
		{
			var mc:MovieClip = e.currentTarget as MovieClip;
			mc.Day.textColor  = textHighlightColor;
			mc.states.gotoAndStop(2);
		}
		
		private function mouseOutFun(e:MouseEvent)
		{
			var mc:MovieClip = e.currentTarget as MovieClip;
			mc.Day.textColor  = textDefaultColor;
			mc.states.gotoAndStop(1);
		}
		
		private function resetFun(e:MouseEvent)
		{
			selectedDays = new Array();
			setTodayDate();
			setCalendar();
			trace("reset");
		}
	}
	
}
