﻿package com
{
	import flash.events.Event;
	import flash.display.MovieClip;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.events.MouseEvent;
	import flash.display.Loader;
	import flash.display.Bitmap;
	import flash.events.ErrorEvent;
	import flash.events.IOErrorEvent;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	
	public class Fish extends MovieClip
	{
		public var numImages:int;
		public var noFishes:int;
		private var XMLData:XML=new XML();
		
		private var shT:shtotal
		private var hT:htotal
		private var TotalText:TotalTxt=new TotalTxt();
		private var ImageHolder:MovieClip;
		
		public function Fish()
		{
			var xmlLoaderObj:URLLoader=new URLLoader();
			xmlLoaderObj.load(new URLRequest("xml/Fish.xml"));
			xmlLoaderObj.addEventListener(Event.COMPLETE,onXMLLoaded);
		}
		
		public function onXMLLoaded(e:Event)
		{
			ImageHolder = new MovieClip();
			addChild(ImageHolder);
			XMLData=XML((e.currentTarget).data);
			reset_btn.addEventListener(MouseEvent.CLICK, onReset);
			reset_btn.dispatchEvent(new MouseEvent(MouseEvent.CLICK));
			addButton();
			AddTotalText();
		}
		
		private function showTotal(e:MouseEvent):void
		{
			shT.visible=false;
			hT.visible=true;
			TotalText.visible=true;
			TotalText.txt.text=""+CalculateTotal();
		}
		private function hideTotal(e:MouseEvent):void
		{
			shT.visible=true;
			hT.visible=false;
			TotalText.visible=false;
		}
		private function CalculateTotal():Number
		{			
			var Total:Number=new Number();
			Total = numImages * noFishes;
			return Total;
		}
		private function AddTotalText():void
		{
			addChild(TotalText);
			TotalText.x=XMLData.TotalText.@xpos;
			TotalText.y=XMLData.TotalText.@ypos;
			TotalText.txt.text="0";
			TotalText.visible=false;
		}
		public function onReset(e:MouseEvent=null):void
		{
			RemoveImagaes();
			TotalText.txt.text=""+CalculateTotal();
		}
		private function addButton()
		{
			shT = new shtotal();
			hT = new htotal();
			addChild(shT);
			addChild(hT);
			
			hT.visible=false;
			/*shT.buttonMode=true;
			hT.buttonMode=true;*/
			
			
			/*shT.addEventListener(MouseEvent.MOUSE_OVER,overState);
			shT.addEventListener(MouseEvent.MOUSE_OUT,outState);*/
			/*hT.addEventListener(MouseEvent.MOUSE_OVER,overState);
			hT.addEventListener(MouseEvent.MOUSE_OUT,outState);*/
			shT.addEventListener(MouseEvent.CLICK,showTotal);
			hT.addEventListener(MouseEvent.CLICK,hideTotal);
			
			shT.x=hT.x=XMLData.ShowHideBtn.@xpos;
			shT.y=hT.y=XMLData.ShowHideBtn.@ypos;		
		}
		private function overState(e:MouseEvent):void
		{
			var Tar=e.currentTarget;
			showOver(Tar);
		}
		
		private function outState(e:MouseEvent):void
		{
			var Tar=e.currentTarget;
			showOut(Tar);
		}
		
		private function showOver(MC:MovieClip):void
		{
			if(MC.currentFrame!=3)
			{
				MC.gotoAndStop(2);
			}
		}
		
		private function showOut(MC:MovieClip):void
		{
			if(MC.currentFrame!=3)
			{
				MC.gotoAndStop(1);
			}
		}
		public function RemoveImagaes()
		{
			var i = 0;
			while(i<ImageHolder.numChildren)
			{
				ImageHolder.removeChildAt(i);
			}
			
			createPuzzle()
		}
		
		public function createPuzzle()
		{
			numImages = Math.ceil(Math.random() * 4);
			if(numImages == 1) 
			{
				noFishes = Math.ceil(Math.random() * 5) + 1;
			}
			else
			{
				noFishes = Math.ceil(Math.random() * 6)
			}
			displayPuzzle();
		}
		
		private function displayPuzzle()
		{
			var urlPath:String = XMLData.images.img[noFishes-1].@href;
			//trace("urlPath "+urlPath);
			var loader:Loader = new Loader()
			var urlRequest:URLRequest = new URLRequest(urlPath);
			loader.contentLoaderInfo.addEventListener(Event.COMPLETE, onImageLoaded);
			loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, ioErrorHandler);
			loader.load(urlRequest);
		}
		
		private function ioErrorHandler(e:ErrorEvent)
		{
			trace("image error "+e)
		}
		private function onImageLoaded(e:Event)
		{
			var bitmap:Bitmap = new Bitmap(e.target.content.bitmapData);
			for(var i = 0; i<numImages;i++)
			{
				var bitmap2:Bitmap = new Bitmap(bitmap.bitmapData);
				bitmap2.width = XMLData.position.image[numImages-1].img[i].@width;
				bitmap2.height = XMLData.position.image[numImages-1].img[i].@height;
				bitmap2.x = XMLData.position.image[numImages-1].img[i].@xpos;
				bitmap2.y = XMLData.position.image[numImages-1].img[i].@ypos;
				ImageHolder.addChild(bitmap2);
			}
		}
	}
}