﻿package com
{
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.display.Bitmap;
	import flash.events.ErrorEvent;
	import flash.events.IOErrorEvent;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.display.Loader;
	import flash.text.TextField;
	import flash.geom.Rectangle;

	public class Biscuit extends MovieClip
	{
		private var noBiscuits:int;
		private var noBags:int;
		private var noBiscuitsPlaced:int = 0;
		private var XMLData:XML=new XML();
		private var ImageHolder:MovieClip;
		private var bitmap:Bitmap;
		private var bagArr:Array;
		private var biscuitArr:Array;
		private var dragging:Boolean = false;
		private var draggingMc:MovieClip;
		
		public function Biscuit()
		{
			noBiscuitsPlaced = 0;
			var xmlLoaderObj:URLLoader=new URLLoader();
			xmlLoaderObj.load(new URLRequest("xml/Fish.xml"));
			xmlLoaderObj.addEventListener(Event.COMPLETE,onXMLLoaded);
			feedBack.visible = false;
		}
		
		
		public function onXMLLoaded(e:Event)
		{
			XMLData=XML((e.currentTarget).data);
			var urlPath:String = XMLData.images.Biscuit.@href;
			var loader:Loader = new Loader()
			var urlRequest:URLRequest = new URLRequest(urlPath);
			loader.contentLoaderInfo.addEventListener(Event.COMPLETE, onBiscuitImageLoaded);
			loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, ioErrorHandler);
			loader.load(urlRequest);
		}
		
		private function overState(e:MouseEvent):void
		{
			var Tar=e.currentTarget;
			showOver(Tar);
		}
		
		private function outState(e:MouseEvent):void
		{
			var Tar=e.currentTarget;
			showOut(Tar);
		}
		
		private function showOver(MC:MovieClip):void
		{
			if(MC.currentFrame!=3)
			{
				MC.gotoAndStop(2);
			}
		}
		
		private function showOut(MC:MovieClip):void
		{
			if(MC.currentFrame!=3)
			{
				MC.gotoAndStop(1);
			}
		}
		public function onReset(e:MouseEvent=null):void
		{
			noBiscuitsPlaced = 0;
			ansTxt.text = "";
			RemoveImagaes();
		}
		
		public function RemoveImagaes()
		{
			generateNumbers();
			createPuzzle();
		}
		
		public function createPuzzle()
		{
			var i = 0;
			while(i<ImageHolder.numChildren)
			{
				ImageHolder.removeChildAt(i);
			}
			bagArr = new Array();
			biscuitArr = new Array();
			feedBack.visible = false;
			questnTxt1.text = String("1/"+noBags);
			questnTxt2.text = String(noBiscuits);
			displayPuzzle();
			checkAnsEnable();
		}
		
		public function generateNumbers()
		{
			var totals:Array;
			totals = String(XMLData.images.Biscuit.@combinations).split(",");
			noBiscuits = totals[(Math.ceil(Math.random() * totals.length)) - 1];
			totals = String(XMLData.images.Bag.@combinations).split(",");
			noBags = totals[(Math.ceil(Math.random() * totals.length)) - 1 ];
		}
		
		private function displayPuzzle()
		{
			var mc:MovieClip = new MovieClip();
			for(var i = 0; i< noBiscuits;i++)
			{
				var bitmap2:Bitmap = new Bitmap(bitmap.bitmapData);
				mc = new MovieClip();
				bitmap2.width = XMLData.images.Biscuit.@width;
				bitmap2.height = XMLData.images.Biscuit.@height;
				bitmap2.x = -bitmap2.width/2;
				bitmap2.y = -bitmap2.height/2;
				mc.x = Number(XMLData.images.Biscuit.@xpos) + (Number(XMLData.images.Biscuit.@gap) *i ) +(bitmap2.width/2);
				mc.y = Number(XMLData.images.Biscuit.@ypos) + (bitmap2.height/2);
				mc.addChild(bitmap2);
				mc.buttonMode = true;
				ImageHolder.addChild(mc);
				biscuitArr.push(mc);
				mc.addEventListener(MouseEvent.MOUSE_DOWN, dragBiscuit);
			}
			onBagImageLoaded();
		}
		private function ioErrorHandler(e:ErrorEvent)
		{
			trace("image error "+e)
		}
		private function onBiscuitImageLoaded(e:Event)
		{
			ImageHolder = new MovieClip();
			addChild(ImageHolder);
			bitmap = new Bitmap(e.target.content.bitmapData);
			reset_btn.addEventListener(MouseEvent.CLICK, onReset);
			reset_btn.dispatchEvent(new MouseEvent(MouseEvent.CLICK));
			
			//checkbt.addEventListener(MouseEvent.MOUSE_OVER,overState);
		//	checkbt.addEventListener(MouseEvent.MOUSE_OUT,outState);
			checkbt.addEventListener(MouseEvent.CLICK,showAnswer);
			stage.addEventListener(MouseEvent.MOUSE_UP, dropBiscuit);
		}
		
		public function dragBiscuit(e:MouseEvent)
		{
			var mc:MovieClip = MovieClip(e.currentTarget);
			//trace("stage.stageWidth "+stage.stageWidth)
			mc.startDrag(true, new Rectangle(50, 10, 660, 430));
			mc.intx = mc.x;
			mc.inty = mc.y;
			mc.ind = mc.parent.getChildIndex(mc);
			mc.parent.setChildIndex(mc, mc.parent.numChildren-1);
			draggingMc = mc;
			dragging = true;
		}
		public function dropBiscuit(e:MouseEvent)
		{
			if(dragging)
			{
				draggingMc.stopDrag();
				for(var i = 0; i< bagArr.length; i++)
				{
					if(draggingMc.hitTestObject(bagArr[i]))
					{
						bagArr[i].holdArr.push(draggingMc);
						draggingMc.visible = false;
						biscuitInBag();
						noBiscuitsPlaced++;
						checkAnsEnable();
						break;
					}
				}
				
				draggingMc.x = draggingMc.intx;
				draggingMc.y = draggingMc.inty;
				draggingMc.parent.setChildIndex(draggingMc, draggingMc.ind);
				dragging = false;
				draggingMc = null;
			}
		}
		private function biscuitInBag()
		{
			for(var i = 0; i< bagArr.length; i++)
			{
				bagArr[i].txt1.text = String(bagArr[i].holdArr.length);
			}
		}
		private function onBagImageLoaded()
		{
			var mc:Bag;
			for(var i = 0; i<noBags;i++)
			{
				mc = new Bag();
				mc.x = Number(XMLData.bagposition.image.(@id == noBags).img[i].@xpos);
				mc.y = Number(XMLData.bagposition.image.(@id == noBags).img[i].@ypos);
				mc.width = Number(XMLData.bagposition.image.(@id == noBags).img[i].@width);
				mc.height = Number(XMLData.bagposition.image.(@id == noBags).img[i].@height);
				mc.hold = 0;
				mc.holdArr = new Array();
				mc.txt1.text = String(mc.hold);
				mc.buttonMode = true;
				mc.txt1.mouseEnabled = false;
				ImageHolder.addChild(mc);
				bagArr.push(mc);
				mc.addEventListener(MouseEvent.CLICK, removeBiscuit);
			}
			biscuitInBag();
		}
		
		public function removeBiscuit(e:MouseEvent)
		{
			var mc:MovieClip = MovieClip(e.currentTarget);
			if(mc.holdArr.length > 0)
			{
				mc.holdArr[mc.holdArr.length-1].visible = true;
				mc.holdArr.splice(mc.holdArr.length-1, 1);
				noBiscuitsPlaced--;
				biscuitInBag();
				checkAnsEnable();
				feedBack.visible = false;
			}
		}
		
		public function checkAnsEnable()
		{
			if(noBiscuitsPlaced == noBiscuits && checkBiscuit())
			{
				//trace("inpt changed")
				//checkbt.mouseChildren = true;
				checkbt.mouseEnabled = true;
				ansTxt.type = "input";
				trace("FOCUESD ")
				ansTxt.selectable=true;
				stage.focus=null;
				//ansTxt.setSelection(0, ansTxt.length);
				stage.focus=ansTxt;
				//checkbt.buttonMode=true;
			}
			else
			{
				ansTxt.selectable=false;
				//trace("still dynamic")
				//ansTxt.type = "dynamic";
				//checkbt.mouseChildren = false;
				checkbt.mouseEnabled = false;
			}
		}
		
		public function checkBiscuit():Boolean
		{
			for(var i = 0; i<bagArr.length;i++)
			{
				var mc:MovieClip = bagArr[i];
				if(mc.holdArr.length != Number(noBiscuits/noBags))
				{
					return false;
					break;
				}
				
			}
			
			return true;
		}
		
		public function showAnswer(e:MouseEvent)
		{
			if(ansTxt.text != "")
			{
				trace("String(noBiscuits/noBags) "+String(noBiscuits/noBags));
				if(Number(ansTxt.text) == Number(noBiscuits/noBags))
				{
					feedBack.gotoAndStop(1);
					feedBack.visible = true;
					//checkbt.mouseChildren = false;
					checkbt.mouseEnabled = false;
					ansTxt.selectable=false;
					//ansTxt.type = "dynamic";
				//	ansTxt.selectable = false;
					remove();
				}
				else
				{
					/*remove();
					createPuzzle();*/
					feedBack.gotoAndStop(2);
					feedBack.visible = true;
				}
			}
		}
		
		private function remove()
		{
			for(var i = 0; i< biscuitArr.length; i++)
			{
				biscuitArr[i].buttonMode = false;
				biscuitArr[i].removeEventListener(MouseEvent.MOUSE_DOWN, dragBiscuit);
			}
			
			for(i = 0; i< bagArr.length; i++)
			{
				bagArr[i].buttonMode = false;
				bagArr[i].removeEventListener(MouseEvent.CLICK, removeBiscuit);
			}
			dragging = false;
			draggingMc = null;
		}
		
	}
}